/**********************************************************************
 **********************************************************************/

#ifndef _TACH_STRUCT_H
#define _TACH_STRUCT_H

#define IPH5526_CAN_QUEUE	32

typedef struct {
	u_short cmnd_code;
	u_short payload_length;
	u_short type_code;
	u_short est_image_pair;
	u_int originator_pa;
	u_int responder_pa;
	u_int service_params;
} PRLI;

typedef struct {
	unsigned short d_naa;
	unsigned short dest_high;
	unsigned int dest_low;
	unsigned short s_naa;
	unsigned short source_high;
	unsigned int source_low;
	} NW_HEADER;

typedef struct {
	unsigned int resv;
	unsigned char sof_and_eof;
	unsigned char dest_alpa;
	unsigned short lcr_and_time_stamp;
	unsigned int r_ctl_and_d_id;
	unsigned int vc_id_and_s_id;
	unsigned int type_and_f_cntl;
	unsigned char seq_id;
	unsigned char df_cntl;
	unsigned short seq_cnt;
	unsigned short ox_id;
	unsigned short rx_id;
	unsigned int ro;
	NW_HEADER nw_header;
	} TACHYON_HEADER;

typedef struct {
	unsigned short service_options;
	unsigned short initiator_ctl;
	unsigned short recipient_ctl;
	unsigned short recv_data_field_size;
	unsigned short concurrent_sequences;
	unsigned short n_port_end_to_end_credit;
	unsigned short open_seq_per_exchange;
	unsigned short resv;
	}CLASS_OF_SERVICE;

typedef struct {
	unsigned int logo_cmnd;
	unsigned char reserved;
	unsigned char n_port_id_2;
	unsigned char n_port_id_1;
	unsigned char n_port_id_0;
	unsigned int port_name_up;
	unsigned int port_name_low;
	} LOGO;

typedef struct {
	unsigned int ls_cmnd_code;
	unsigned int hard_address;
	unsigned int port_name_high;
	unsigned int port_name_low;
	unsigned int node_name_high;
	unsigned int node_name_low;
	unsigned int n_port_id;
	} ADISC;
	
typedef struct {
	unsigned int cmnd_code;
	unsigned int reason_code;
	} LS_RJT;

typedef struct {
	unsigned int cmnd_code;
	} ACC;

typedef struct  {
	unsigned int seq_d_id;
	unsigned int tot_len;
	unsigned short cntl;
	unsigned short rx_id;
	unsigned short cs_enable;
	unsigned short cs_seed;
	unsigned int trans_id;
	unsigned int hdr_addr;
	unsigned short frame_len;
	unsigned short hdr_len;
	unsigned int edb_addr;
	}ODB;

typedef struct {
	unsigned int cmnd_code;
	unsigned int reg_function; /* in the last byte */
	} SCR;

typedef struct {
	unsigned int rev_in_id;

	unsigned char fs_type;
	unsigned char fs_subtype;
	unsigned char options;
	unsigned char resv1;

	unsigned short cmnd_resp_code;
	unsigned short max_res_size;

	unsigned char resv2;
	unsigned char reason_code;
	unsigned char expln_code;
	unsigned char vendor_unique;
	} CT_HDR;

typedef struct {
	CT_HDR	 ct_hdr;
	unsigned int s_id;
	unsigned char bit_map[32]; /* 32 byte bit map */
	} RFC_4;


typedef struct {
	unsigned int ls_cmnd_code;
	unsigned short fc_ph_version;
	unsigned short buff_to_buff_credit;
	unsigned short common_features;
	unsigned short recv_data_field_size;
	unsigned short n_port_total_conc_seq;
	unsigned short rel_off_by_info_cat;
	unsigned int ED_TOV;
	unsigned int n_port_name_high;
	unsigned int n_port_name_low;
	unsigned int node_name_high;
	unsigned int node_name_low;
	CLASS_OF_SERVICE c_of_s[3];
	unsigned int resv[4];
	unsigned int vendor_version_level[4];
	}LOGIN;

typedef struct { 
        u_int cmnd_code;
        u_int revision;	// only the first char is useful, other bits are reserved
        u_int ra_tov;
        u_int ed_tov;
        u_int E_Port_Name[2];
	u_int Switch_Name[2];  		//[0] high, [1] low

	u_int   class_f_valid;   	// only bit 31 useful
 	u_short class_f_XII;     	// only bit 29 useful, normally set to 0
        u_short class_f_frame_size; 	// receive data field size
	u_short class_f_con_seq; 	// concurrent sequences
	u_short class_f_credit;		// end-to-end credit
	u_int   class_f_seqs;		// open sequences per exchange, only the fire short useful
     
	u_int	class_1_params;		// class 1 parameters
        u_int   class_2_params;         // class 2 parameters 
        u_int   class_3_params;         // class 3 parameters 

        u_int 	reserved[5];		// reserved 20 bytes
     
  	u_short ISL_mode;		// ISL flow control mode
	u_short flow_cntl_len;		// flow control parameter length
	// it is possible to add ISL flow contol here if it has 
        } ELP;

typedef struct {
        u_short cmnd_code;
        u_short payload_len; 
        u_int   verderID[2];
        u_int   protocol[3];
	// it is possible to have more than one protocol section, till now, we use only one
	// ESC is proposed by Ancor
	} ESC;    // exchange switch capabilities


typedef struct {
        u_char  cmnd_code;   // = 0x11
	u_char  rcd_lengh;   // = 0x10
        u_short payload_len;
        u_int   priority;    // only the last byte is meaningful
        u_int   sw_name[2];  // the priority and sw_name are for the Principal Switch
        // it is possible to have more than zero domain ID  in the list
        } EFP;

typedef struct {
        u_int   cmnd_code;   // = 0x12
        u_int   sw_name[2];  // originating switch name
	u_int	orig_id;     // originating port address identifier	
        } AAI;

typedef struct {
        u_short  cmnd_code;   // = 0x1300
        u_short  payload_len;  
        u_int    sw_name[2];   // requesting Switch_Name
	u_int 	 requested_id; // only the last byte is meaningful
		// normally we only ask for one domain ID
        } RDI;

typedef struct {
	u_int cmnd_code;	// = 0x14
	u_int version;		// = 0x02000000
	u_int src_id;		// originating domain ID
	u_int auth[2];		// authentication
		// the above is the sub header
	u_int options;
	u_int hello_intv;
	u_int dead_intv;
	u_int recv_id;
	u_int port_id;
	} HELLO;

typedef struct {
	u_int cmnd_code;        // = 0x15 or 0x16
        u_int version;          // = 0x00000002
        u_int src_id;           // originating domain ID
        u_int auth[2];          // authentication
                // the above is the sub header
	u_int flags;
	u_int num;
	} LS;

struct  link_data {
	u_int neighbor;
	u_int outPort;
	u_int neighborPort;
	u_short type;
	u_short cost;
	};

struct lsr_header {
	u_short type;
	u_short age;
	u_int   options;
	u_int   id;
	u_int   adv_id;	// advertising Domain ID
	u_int   incarnation;
	u_short checksum;
	u_short length;
	};     // 24 bytes
	  	 	  	
typedef struct {
	CT_HDR	 ct_hdr;
	unsigned int port_type; /* in the first byte */
	} GP_ID4;

typedef struct  {
	unsigned int   buf_addr;
	unsigned short ehf;
	unsigned short buf_len;
	}EDB;

/* (i)chip Registers */
struct i_chip_regs {
	unsigned int	ptr_ichip_hw_control_reg;
	unsigned int	ptr_ichip_hw_status_reg;
	unsigned int	ptr_ichip_hw_addr_mask_reg;
};

struct iph5526_novram {
	unsigned int	ptr_novram_hw_control_reg;
	unsigned int	ptr_novram_hw_status_reg;
	unsigned short data[IPH5526_NOVRAM_SIZE];
};

/* Tachyon Registers */
struct tachyon_regs {
	unsigned int    ptr_ocq_base_reg;
	unsigned int    ptr_ocq_len_reg;
	unsigned int    ptr_ocq_prod_indx_reg;
	unsigned int    ptr_ocq_cons_indx_reg;

	unsigned int    ptr_hpcq_base_reg;
	unsigned int    ptr_hpcq_len_reg;
	unsigned int    ptr_hpcq_prod_indx_reg;
	unsigned int    ptr_hpcq_cons_indx_reg;

	unsigned int    ptr_imq_base_reg;
	unsigned int    ptr_imq_len_reg;
	unsigned int    ptr_imq_cons_indx_reg;
	unsigned int    ptr_imq_prod_indx_reg;

	unsigned int    ptr_mfsbq_base_reg;
	unsigned int    ptr_mfsbq_len_reg;
	unsigned int    ptr_mfsbq_prod_reg;
	unsigned int    ptr_mfsbq_cons_reg;
	unsigned int    ptr_mfsbuff_len_reg;

	unsigned int    ptr_sfsbq_base_reg;
	unsigned int    ptr_sfsbq_len_reg;
	unsigned int    ptr_sfsbq_prod_reg;
	unsigned int    ptr_sfsbq_cons_reg;
	unsigned int    ptr_sfsbuff_len_reg;

	unsigned int    ptr_sest_base_reg;
	unsigned int    ptr_sest_len_reg;
	unsigned int    ptr_sestbuff_len_reg;

	unsigned int    ptr_tach_config_reg;
	unsigned int    ptr_tach_control_reg;
	unsigned int    ptr_tach_status_reg;
	unsigned int    ptr_tach_flush_oxid_reg;
	unsigned int    ptr_tach_ee_cr_0_tmr_reg;
	unsigned int    ptr_tach_bb_cr_0_tmr_reg;
	unsigned int    ptr_tach_rx_frm_err_reg;

	unsigned int    ptr_fm_config_reg;
	unsigned int    ptr_fm_control_reg;
	unsigned int    ptr_fm_status_reg;
	unsigned int    ptr_fm_tov_reg;
	unsigned int    ptr_fm_link_stat_1_reg;
	unsigned int    ptr_fm_link_stat_2_reg;
	unsigned int    ptr_fm_wwn_hi_reg;
	unsigned int    ptr_fm_wwn_low_reg;
	unsigned int    ptr_fm_rx_al_pa_reg;
	unsigned int    ptr_fm_prim_reg;
};


/* principal switch selection state machine */
struct sw_sm {
	u_char	psw_card;		// 0xFF means myself is the psw
	u_char 	cur_domainID;		// the first available domain ID , used by RDI processing
	u_char	psw_selected : 1;
	u_char  elp_timer_set : 1;
	u_char  efp_timer_set : 1;
	u_char  bf_timer_set : 1;
	u_char  started_2FS_TOV : 1;
	u_char  elp_done : 1;
	u_char  esc_done : 1;
	u_char  my_efp_done : 1;
	u_char  got_domainID : 1;
	u_int 	testing;    // the testing code.
        struct 	timer_list efp_timer;
	struct  timer_list elp_timer;
	struct  timer_list bf_timer;
        };

/* routing structs*/
struct NODE {
        u_int id;   
        u_int iDist;
        u_int iPrev;   
        u_int first_hop;
	u_int src_port;
	};      
        
struct vertex    // the vertices
	{
        u_int order;
        struct vertex *next; 
	};

struct link_info {
        u_int neighbor;
        u_int outPort;
        u_int neighborPort;
        u_short type;
        u_short cost;
	struct link_info * next;
	};

struct lsr_info {
        u_short type;
        u_short age;
        u_int   options;
        u_int   id;
        u_int   adv_id; // advertising Domain ID
        u_int   incarnation;
	u_short checksum;
	u_short length;
		// LSR header 6 words

	u_char  is_new;	// is it a newly added or updated lsr which has not been transmitted in LSU?
	struct link_info *link_list; 
	struct lsr_info *next;
	};
        
struct route{
	u_char hello_txed : 1;
	u_char hello_timer_set : 1;
	u_char dead_timer_set : 1;
	u_char hello_rxed : 1;
	u_char first_lsu_txed : 1;
	u_char done_db_init : 1;
	u_int  adj_domain;		//adjacent domain id
	u_int  adj_port;		//adjacent switch port
        u_int node_num; 
        struct vertex *vhead;
        u_int AdjMatrix[NUM_NODES][NUM_NODES];
        struct  NODE nodes[NUM_NODES];
	struct  lsr_info *lsr_list;	
	struct  timer_list hello_timer;
	struct  timer_list dead_timer;
	};

struct globals {
	unsigned long tachyon_base;
	unsigned int *mem_base;
	unsigned short ox_id; /* OX_ID used for IP and ELS frames */
	u_short scsi_oxid; /* OX_ID for SEST entry */
	unsigned char seq_id;
	unsigned int my_id;
	unsigned int my_ddaa; /* my domain and area in a fabric */
	unsigned char loop_up;
	unsigned char ptp_up; /* we have a point-to-point link */
	unsigned char link_up;
	unsigned char n_port_try;
	unsigned char nport_timer_set;
	unsigned char lport_timer_set;
	/* Hmmm... We dont want to Initialize while closing */
	unsigned char dont_init; 
	unsigned int my_node_name_high;
	unsigned int my_node_name_low;
	unsigned int my_port_name_high;
	unsigned int my_port_name_low;
	unsigned char fabric_present;
	//unsigned char explore_fabric;
	//unsigned char name_server;  
	unsigned int my_mtu;
	unsigned int *els_buffer[MAX_PENDING_FRAMES]; /* temp space for ELS frames */
	unsigned char *arp_buffer; /* temp space for ARP frames */
	unsigned int mfs_buffer_count; /* keep track of MFS buffers used*/
	unsigned char scsi_registered;
	/* variables for port discovery */
	unsigned short alpa_list_index;
	unsigned short type_of_frame; /* Could be IP/SCSI Read/SCSI Write*/	
	unsigned char no_of_targets; /* used to assign target_ids */
	unsigned long sem; /* to synchronize between IP and SCSI */
	unsigned char e_i;

	/* the frames */
	TACHYON_HEADER tach_header;
	LOGIN login;
	PRLI prli;
	LOGO logo;
	ADISC adisc;
	LS_RJT ls_rjt;
	ODB	odb;
	ACC	acc;
	SCR	scr;
	EDB	edb;
	RFC_4 rfc_4;
	GP_ID4 gp_id4;

	/********  E_Port stuff ********/
        u_char	card_order; 	// from 0 ...
	u_char	my_domainID;
        u_char  i_am_fabric;
        u_char  i_am_E_Port;

	u_char	from_card;	// this frame is frame which card: 0, or 1, or ...
				// 99 means generated by the switch
	u_int	mysw_name[2];   // my switch name

	u_int   psw_priority;
	u_int   psw_name[2];   	// principal switch priority and name		
	
	/*for debugging purposes */
	int interrupt_count;
	unsigned int *tachyon_header;
	unsigned int *ptr_tachyon_header;
	unsigned int my_alpa;
};

struct queue_variables {
	unsigned int *host_ocq_cons_indx, *host_hpcq_cons_indx, *host_imq_prod_indx;
	unsigned int *ptr_host_ocq_cons_indx, *ptr_host_hpcq_cons_indx, *ptr_host_imq_prod_indx;
	unsigned int *ptr_ocq_base;
	unsigned int ocq_len, ocq_end;
	unsigned int ocq_prod_indx;
	unsigned int *ptr_odb[OCQ_LEN];

	unsigned int *ptr_imq_base;
	unsigned int imq_len, imq_end;
	unsigned int imq_cons_indx;
	unsigned int imq_prod_indx;
	unsigned int *ptr_imqe[IMQ_LEN];

	unsigned int *ptr_mfsbq_base;
	unsigned int mfsbq_len, mfsbq_end;
	unsigned int mfsbq_prod_indx;
	unsigned int mfsbq_cons_indx;
	unsigned int mfsbuff_len, mfsbuff_end;

	unsigned int *ptr_sfsbq_base;
	unsigned int sfsbq_len, sfsbq_end;
	unsigned int sfsbq_prod_indx;
	unsigned int sfsbq_cons_indx;
	unsigned int sfsbuff_len, sfsbuff_end;
	//struct sk_buff *sfs_skb_list[SFSBQ_LEN * BUFF_ADDRS];
	unsigned int *ptr_sfs_buffers[SFSBQ_LEN * BUFF_ADDRS];

	unsigned int *ptr_sest_base;
	unsigned int *ptr_sest[SEST_LEN];
	unsigned char free_scsi_oxid[SEST_LEN];
	unsigned int *ptr_sdb_base;
	unsigned int *ptr_sdb_slot[NO_OF_SDB_ENTRIES];
	unsigned int sdb_indx;
	unsigned int *ptr_fcp_cmnd_base;
	unsigned int *ptr_fcp_cmnd[NO_OF_FCP_CMNDS];
	unsigned int fcp_cmnd_indx;

	/*pointers for the EDBs */
	unsigned int *ptr_edb_base;
	unsigned int *ptr_edb[EDB_LEN];
	unsigned int edb_buffer_indx;
	volatile unsigned char free_edb_list[EDB_LEN];
	
	unsigned int *ptr_tachyon_header[NO_OF_TACH_HEADERS];
	unsigned int *ptr_tachyon_header_base;
	unsigned int tachyon_header_indx;
};

/* Used to match incoming ACCs to ELS requests sent out */
struct ox_id_els_map {
	u_short ox_id;
	u_char  from_card;	
	u_int els;
	struct ox_id_els_map *next;
};


/* Maintain a list of OX_ID so that we can use them while aborting
 * an Exchange.
 */
struct active_oxids {
	u_short ox_id;
	struct active_oxids *next;
};

/* Carries info about individual nodes... stores the info got at login 
 * time. Also maintains mapping between MAC->FC addresses 
 */
struct fc_node_info {
	/* Itz the WWN (8 bytes), the last 6 bytes is the MAC address */
	unsigned char hw_addr[PORT_NAME_LEN]; 
	unsigned char node_name[NODE_NAME_LEN]; 
	unsigned int d_id;  /*real FC address, 3 bytes */
	int mtu;
	/* login = 1 if login attempted
	 * login = 2 if login completed 
	 */
	int login;    
	u_char scsi; /*  = 1 if device is a SCSI Target */
	u_char target_id;
	CLASS_OF_SERVICE c_of_s[3];
	struct active_oxids *active_oxid_list;
	struct fc_node_info *next;
};

struct fc_info {
	const char *name;
	unsigned long *maddr;
	int irq;
	struct net_device_stats fc_stats;
	struct fc_node_info *node_info_list;
	struct ox_id_els_map *ox_id_list;
	struct i_chip_regs i_r;
	struct tachyon_regs t_r;
	struct queue_variables q;
	struct globals g;
	struct iph5526_novram n_r;
	u_short clone_id;
	struct timer_list nport_timer;
	struct timer_list lport_timer;
	//struct timer_list explore_timer;
	struct device *dev;
	struct semaphore fc_sem;
	spinlock_t fc_lock;
	
	struct sw_sm 	sm;	// sw state machine	
	struct route	rt;
        struct port_info *name_list;    // for name server
	struct domain_id *domain_ids;
};


/* List of valid AL_PAs */
unsigned char alpa_list[127] = { 
	0x00, 0x01, 0x02, 0x04, 0x08, 0x0F, 0x10, 0x17, 
	0x18, 0x1B, 0x1D, 0x1E, 0x1F, 0x23, 0x25, 0x26, 
	0x27, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x31, 
	0x32, 0x33, 0x34, 0x35, 0x36, 0x39, 0x3A, 0x3C, 
	0x43, 0x45, 0x46, 0x47, 0x49, 0x4A, 0x4B, 0x4C, 
	0x4D, 0x4E, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 
	0x59, 0x5A, 0x5C, 0x63, 0x65, 0x66, 0x67, 0x69, 
	0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x71, 0x72, 0x73, 
	0x74, 0x75, 0x76, 0x79, 0x7A, 0x7C, 0x80, 0x81, 
	0x82, 0x84, 0x88, 0x8F, 0x90, 0x97, 0x98, 0x9B, 
	0x9D, 0x9E, 0x9F, 0xA3, 0xA5, 0xA6, 0xA7, 0xA9, 
	0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xB1, 0xB2, 0xB3, 
	0xB4, 0xB5, 0xB6, 0xB9, 0xBA, 0xBC, 0xC3, 0xC5, 
	0xC6, 0xC7, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 
	0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD9, 0xDA, 
	0xDC, 0xE0, 0xE1, 0xE2, 0xE4, 0xE8, 0xEF
};


struct port_info {
        
        u_int portID;
   
        
        u_int port_name_high;
        u_int port_name_low;
        u_int s_port_name[64];  //symbolic port name
        
        u_int node_name_high;
        u_int node_name_low;
        u_int s_node_name[64];  //symbolic node name
        
        u_int initial_pa[2];    // initial process associator
        u_int ip[4];
        u_int class_service;     //class of service

        u_int FC_4_types[8];         /* 32 byte fc-4 types */
        u_int portType;

	u_int ip_port[4];
	u_int fabric_name_high;
	u_int fabric_name_low;
	u_int hard_address;

        struct port_info  *next;

        u_int SET_FLAG;  
        /* to indicate which member was set, the ID, wwn, nodename and class of service info are
           always hold because the name server could get them from PLOGI. 
        */
        };

struct domain_id {
        u_char  type;
        u_char  id;
        u_int   sw_name[2];  
	struct domain_id *next;
        };    // domain ID list record used for E_Port


#endif /* _TACH_STRUCT_H */


// end of file






// end of file 2
